﻿Imports System.Windows.Threading
Partial Public Class Page
 Inherits UserControl
 Const CellW As Integer = 50, CellH As Integer = 50
 Dim rndm As Random
 Dim tabNombres() As Integer
 Dim tabRectangles() As Rectangle
 Dim tabTbValeurs() As TextBlock
 Dim timer As DispatcherTimer
 Public Sub New()
  InitializeComponent()
 End Sub
 Private Sub LayoutRoot_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
  tabNombres = New Integer(8) {} ' tableau de nombres au hasard à trier
  tabRectangles = New Rectangle(8) {} ' tableau des rectangles représentant ces nombres
  tabTbValeurs = New TextBlock(8) {} ' tableau des TextBlock affichant ces valeurs
  For i As Integer = 0 To 8 ' créer les 9 TextBlock contenant ces valeurs
   Dim tb As New TextBlock()
   tb.SetValue(Canvas.LeftProperty, CDbl(60 + i * 75))
   tb.SetValue(Canvas.TopProperty, 500.0)
   tb.SetValue(TextBlock.NameProperty, "tb" & i)
   tb.FontSize = 30
   tb.Foreground = New SolidColorBrush(Colors.Black)
   tb.Text = ""
   tabTbValeurs(i) = tb
   LayoutRoot.Children.Add(tb)
  Next i
  timer = New DispatcherTimer()
  timer.Interval = New TimeSpan(0, 0, 0, 0, 500)
  AddHandler timer.Tick, AddressOf timer_Tick
 End Sub

 Private Sub resetValues()
  animCanvas.Children.Clear()
  For i As Integer = 0 To 8
   tabTbValeurs(i).Foreground = New SolidColorBrush(Colors.Black)
   tabTbValeurs(i).Text = ""
  Next i
 End Sub
 Private Sub InitialisationDesValeurs()
  rndm = New Random()
  For i As Integer = 0 To 8 ' 9 nombres au hasard entre (inclus) 1 and 9
   Dim N As Integer = rndm.Next(1, 10)
   tabNombres(i) = N
   InitialiserValeur(i, N)
  Next i
 End Sub

 Private Sub InitialiserValeur(ByVal i As Integer, ByVal N As Integer)
  ' créer un rectangle représentant un nombre au hasard
  Dim r As New Rectangle()
  r.SetValue(Rectangle.NameProperty, "rc" & i)
  r.SetValue(Canvas.LeftProperty, 50.0 + (i * 75))
  r.SetValue(Canvas.TopProperty, 0.0)
  r.Width = 50
  r.Fill = New SolidColorBrush(Colors.Black)

  Dim stb As New Storyboard()
  stb.Duration = New Duration(New TimeSpan(0, 0, 0, 2, 500))
  Dim dakf As New DoubleAnimationUsingKeyFrames()
  Dim sdkf As New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0))
  sdkf.Value = Math.Min(10 * CellH, (N + 5) * CellH)
  dakf.KeyFrames.Add(sdkf)
  sdkf = New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0, 0, 0, 0, 250))
  sdkf.Value = Math.Max(0, (N - 5) * CellH)
  dakf.KeyFrames.Add(sdkf)
  sdkf = New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0, 0, 0, 0, 500))
  sdkf.Value = Math.Min(10 * CellH, (N + 2) * CellH)
  dakf.KeyFrames.Add(sdkf)
  sdkf = New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0, 0, 0, 0, 750))
  sdkf.Value = Math.Max(0, (N - 2) * CellH)
  dakf.KeyFrames.Add(sdkf)
  sdkf = New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0, 0, 0, 0, 1000))
  sdkf.Value = Math.Min(10 * CellH, (N + 1) * CellH)
  dakf.KeyFrames.Add(sdkf)
  sdkf = New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0, 0, 0, 1, 250))
  sdkf.Value = Math.Max(0, (N - 1) * CellH)
  dakf.KeyFrames.Add(sdkf)
  sdkf = New SplineDoubleKeyFrame()
  sdkf.KeyTime = KeyTime.FromTimeSpan(New TimeSpan(0, 0, 0, 1, 500))
  sdkf.Value = N * CellH
  dakf.KeyFrames.Add(sdkf)
  Storyboard.SetTargetProperty(dakf, New PropertyPath("Height"))
  dakf.BeginTime = New TimeSpan(0, 0, 0, 0, 100 * i)
  stb.Children.Add(dakf)
  r.Resources.Add("Storyboard", stb)

  Dim stbRcBlink As New Storyboard()
  stbRcBlink.SetValue(NameProperty, "stbRc" & i & "Blink")
  Dim da As New DoubleAnimation()
  Storyboard.SetTargetProperty(da, New PropertyPath("Opacity"))
  Storyboard.SetTarget(stbRcBlink, r)
  da.AutoReverse = True
  da.RepeatBehavior = RepeatBehavior.Forever
  da.Duration = New Duration(New TimeSpan(0, 0, 0, 0, 500))
  stbRcBlink.Children.Add(da)
  r.Resources.Add("Storyboard2", stbRcBlink)

  tabRectangles(i) = r
  animCanvas.Children.Add(r)

  Storyboard.SetTargetName(stb, "rc" & i)
  AddHandler stb.Completed, AddressOf stbRcInitAnim_Completed
  stb.Begin()
 End Sub
 Private Sub stbRcInitAnim_Completed(ByVal sender As Object, ByVal e As EventArgs)
  ' afficher les 9 valeurs aussitôt que l'animation est terminée
  For i As Integer = 0 To 8
   tabTbValeurs(i).Text = tabNombres(i).ToString()
  Next i
 End Sub

 Friend Enum Etapes
  Présentation
  Comparaison
  NextBoucle
 End Enum
 Private N1, N2, iPlusPetit, nPlusPetit As Integer ' valeur du plus petit courant
 Private nextEtape As Etapes
 Private bRectanglesEnCoursDepl As Boolean

 Private Sub timer_Tick(ByVal sender As Object, ByVal e As EventArgs)
  If bRectanglesEnCoursDepl Then
   Return
  End If
  Dim stb As Storyboard
  Select Case nextEtape
   Case Etapes.NextBoucle ' démarrer une nouvelle boucle
    If N1 >= 8 Then
     tabRectangles(8).Fill = New SolidColorBrush(Colors.Blue)
     tabTbValeurs(8).Foreground = New SolidColorBrush(Colors.Blue)
     Return ' fin du tri
    End If
    ' N1 est candidat à l'échange. Nous allons essayer de trouver un plus petit nombre dans la suite à droite
    tabRectangles(N1).Fill = New SolidColorBrush(Colors.Red)
    N2 = N1 + 1
    iPlusPetit = -1
    nPlusPetit = 100
    stb = CType(FindName("stbRc" & N1 & "Blink"), Storyboard) ' montrer que N1 est candidat à l'échange
    stb.Begin()
    nextEtape = Etapes.Comparaison
    timer.Start()

   Case Etapes.Présentation
    ' montrer le rectangle qui est en cours de comparaison
    tabRectangles(N2).Fill = New SolidColorBrush(Colors.Green)
    nextEtape = Etapes.Comparaison
    If N2 > 8 Then ' fin de suite à droite
     Exchange()
    End If
    timer.Start()

   Case Etapes.Comparaison
    tabRectangles(N2).Fill = New SolidColorBrush(Colors.Black)
    If tabNombres(N2) < tabNombres(N1) Then
     ' plus petit que le plus petit précédent ?
     If tabNombres(N2) < nPlusPetit Then
      If iPlusPetit <> -1 Then
       ' mettre fin au clignotement 
       tabRectangles(iPlusPetit).Fill = New SolidColorBrush(Colors.Black)
       stb = CType(FindName("stbRc" & iPlusPetit & "Blink"), Storyboard)
       stb.Stop()
      End If
      ' montrer que le nouveau "plus petit" est candidat à l'échange
      tabRectangles(N2).Fill = New SolidColorBrush(Colors.Red)
      stb = CType(FindName("stbRc" & N2 & "Blink"), Storyboard)
      iPlusPetit = N2
      nPlusPetit = tabNombres(N2)
      stb.Begin()
     End If

    End If
    If N2 = 8 Then ' fin de boucle, peut-être faut-il procéder à l'échange
     Exchange()
     Return
    End If
    nextEtape = Etapes.Présentation
    N2 += 1
    timer.Start()
  End Select
 End Sub
 Private Sub Exchange()
  ' deux nombres (en N1 et iSmallest) sont candidat à l'échange
  If iPlusPetit <> 8 Then
   tabRectangles(8).Fill = New SolidColorBrush(Colors.Black)
  End If
  Dim stb As Storyboard
  If iPlusPetit <> -1 Then
   bRectanglesEnCoursDepl = True
   ' démarrer le déplacement
   ' mettre fin au clignotement des deux candidats
   stb = CType(FindName("stbRc" & N1 & "Blink"), Storyboard)
   stb.Stop()
   stb = CType(FindName("stbRc" & iPlusPetit & "Blink"), Storyboard)
   stb.Stop()

   ' les deux candidats à l'échange sont remplavcés par des rectangles jaunes en mouvement
   tabRectangles(N1).Opacity = 0
   tabRectangles(iPlusPetit).Opacity = 0

   ' préparer le rectangle jaune en mouvement de gauche à droite
   rcMove1.Opacity = 1
   Dim left As Double = CDbl(tabRectangles(N1).GetValue(Canvas.LeftProperty))
   rcMove1.SetValue(Canvas.LeftProperty, left)
   Dim top As Double = CDbl(tabRectangles(N1).GetValue(Canvas.TopProperty))
   rcMove1.SetValue(Canvas.TopProperty, top)
   rcMove1.Width = tabRectangles(N1).Width
   rcMove1.Height = tabRectangles(N1).Height
   daMove1.To = CDbl(tabRectangles(iPlusPetit).GetValue(Canvas.LeftProperty))
   stbRcMove1.Begin()

   ' préparer le rectangle jaune en mouvement de droite à gauche
   rcMove2.Opacity = 1
   left = CDbl(tabRectangles(iPlusPetit).GetValue(Canvas.LeftProperty))
   rcMove2.SetValue(Canvas.LeftProperty, left)
   top = CDbl(tabRectangles(iPlusPetit).GetValue(Canvas.TopProperty))
   rcMove2.SetValue(Canvas.TopProperty, top)
   rcMove2.Width = tabRectangles(iPlusPetit).Width
   rcMove2.Height = tabRectangles(iPlusPetit).Height
   daMove2.To = CDbl(tabRectangles(N1).GetValue(Canvas.LeftProperty))
   stbRcMove2.Begin()
  Else
   ' aucun échange à effectuer
   stb = CType(FindName("stbRc" & N1 & "Blink"), Storyboard)
   stb.Stop()
   tabRectangles(N1).Fill = New SolidColorBrush(Colors.Blue)
   tabTbValeurs(N1).Foreground = New SolidColorBrush(Colors.Blue)
   N1 += 1
   nextEtape = Etapes.NextBoucle
   timer.Start()
  End If
  If N1 >= 8 Then
   tabRectangles(8).Fill = New SolidColorBrush(Colors.Blue)
   tabTbValeurs(8).Foreground = New SolidColorBrush(Colors.Blue)
  End If

 End Sub

 Private Sub stbRcMove2_Completed(ByVal sender As Object, ByVal e As EventArgs)
  ' fin animation de déplacement
  rcMove1.Opacity = 0
  rcMove2.Opacity = 0
  tabRectangles(N1).Height = tabNombres(iPlusPetit) * CellH
  tabRectangles(N1).Fill = New SolidColorBrush(Colors.Blue) ' N1 est correctement placé

  ' procéder à l'échange
  Dim n As Integer = tabNombres(N1)
  tabNombres(N1) = tabNombres(iPlusPetit)
  tabTbValeurs(N1).Text = tabNombres(iPlusPetit).ToString()
  tabNombres(iPlusPetit) = n
  tabRectangles(N1).Opacity = 1
  tabTbValeurs(N1).Foreground = New SolidColorBrush(Colors.Blue)

  tabRectangles(iPlusPetit).Height = n * CellH
  tabRectangles(iPlusPetit).Fill = New SolidColorBrush(Colors.Black)
  tabTbValeurs(iPlusPetit).Text = n.ToString()
  tabRectangles(iPlusPetit).Opacity = 1

  bRectanglesEnCoursDepl = False

  N1 += 1
  nextEtape = Etapes.NextBoucle
 End Sub
 Private Sub bGenerateNumbers_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
  timer.Stop()
  If bRectanglesEnCoursDepl Then
   Return
  End If
  resetValues()
  InitialisationDesValeurs()
 End Sub

 Private Sub bTri_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
  N1 = 0
  nextEtape = Etapes.NextBoucle
  timer.Start()
 End Sub
End Class